package com.halo.halojuhesdk.core.request;


import android.util.Log;

import com.halo.halojuhesdk.core.base.net.AbstractNetProcessor;
import com.halo.halojuhesdk.core.base.net.AbstractNetTask;
import com.halo.halojuhesdk.core.base.utils.LogUtils;
import javax.net.ssl.HttpsURLConnection;

/**
 * 请求数据的percessor
 */

public class StatProcessor extends AbstractNetProcessor {

    private String mReqId;
    private String mPostjson;

    public StatProcessor(String postjson, String reqId) {
        mPostjson = postjson;
        mReqId = reqId;
    }

    @Override
    protected AbstractNetTask createTask() {
        return new StatTask(mPostjson, mReqId);
    }


    @Override
    public void finish(int code, String content) {
        if (code == HttpsURLConnection.HTTP_OK) {
            LogUtils.e("==StatProcessor===" + mPostjson);
        }
    }

    @Override
    public void onError(int code, String content) {
        //根据code 判断是否需要增加失败次数
        Log.e("==StatProcessorError===", "code:  " + code + " content: " + content);
    }
}
